"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _invariant = _interopRequireDefault(require("invariant"));

var _Store = _interopRequireDefault(require("./Store"));

var _StoreFactory = _interopRequireDefault(require("./StoreFactory"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var HINT_LINK = 'Learn more about defining stores:' + ' https://github.com/HubSpot/general-store#create-a-store';

function dropFirstArg(func) {
  return function (head) {
    for (var _len = arguments.length, tail = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      tail[_key - 1] = arguments[_key];
    }

    return func.apply(void 0, tail);
  };
}

var StoreSingleton = /*#__PURE__*/function () {
  function StoreSingleton() {
    var _this = this;

    _classCallCheck(this, StoreSingleton);

    _defineProperty(this, "_facade", void 0);

    _defineProperty(this, "_factory", void 0);

    _defineProperty(this, "_getter", void 0);

    this._facade = null;
    this._factory = new _StoreFactory.default({
      getter: function getter(state) {
        if (typeof _this._getter !== 'function') {
          return undefined;
        }

        for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        return _this._getter.apply(_this, args);
      }
    });
    this._getter = null;
  }

  _createClass(StoreSingleton, [{
    key: "defineGet",
    value: function defineGet(getter) {
      (0, _invariant.default)(!this.isRegistered(), 'StoreSingleton.defineGet: this store definition cannot be modified' + ' because it has already been registered with a dispatcher. %s', HINT_LINK);
      (0, _invariant.default)(typeof getter === 'function', 'StoreSingleton.defineGet: expected getter to be a function but got' + ' "%s" instead. %s', getter, HINT_LINK);
      this._getter = getter;
      return this;
    }
  }, {
    key: "defineName",
    value: function defineName(name) {
      this._factory.defineName(name);

      return this;
    }
  }, {
    key: "defineResponseTo",
    value: function defineResponseTo(actionTypes, response) {
      (0, _invariant.default)(!this.isRegistered(), 'StoreSingleton.defineResponseTo: this store definition cannot be' + ' modified because is has already been registered with a dispatcher. %s', HINT_LINK);
      this._factory = this._factory.defineResponseTo(actionTypes, dropFirstArg(response));
      return this;
    }
  }, {
    key: "isRegistered",
    value: function isRegistered() {
      return this._facade instanceof _Store.default;
    }
  }, {
    key: "register",
    value: function register(dispatcher) {
      (0, _invariant.default)(typeof this._getter === 'function', 'StoreSingleton.register: a store cannot be registered without a' + ' getter. Use GeneralStore.define().defineGet(getter) to define a' + ' getter. %s', HINT_LINK);

      if (!this._facade) {
        this._facade = this._factory.register(dispatcher);
      }

      return this._facade;
    }
  }]);

  return StoreSingleton;
}();

exports.default = StoreSingleton;